/*
 *  Disclaimer and terms of usage
 *  -----------------------------
 *  Redistribution and use in source and binary forms, with or without modification,
 *  are permitted provided that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright notice,
 *     this list of conditions and the following disclaimer in the documentation
 *     and/or other materials provided with the distribution.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 *  THE POSSIBILITY OF SUCH DAMAGE.
*/
/*
 * TimerMgr.h
 *
 *  Created on: Jul 9, 2015
 *      Author: khgoh
 */

#ifndef INC_TIMERMGR_H_
#define INC_TIMERMGR_H_

/*
 * This Timer Manager will be making use of the PollMgr module
 * To handle the FD.
 * Once trigger, will do the callback.
 */

/*
 * Call to create a time, on success, will return the timerid.
 * or else, will return zero.
 * name length is 16 char or less.
 */
int TimerMgr_Create(char *name, long delay_ms, unsigned char isRepeat,
				void (*cb)(int timerid,void*ptr), void *ptr);

/*
 * Call to start the timer
 */
void TimerMgr_Start(int timerid);

/*
 * Call to stop the timer
 */
void TimerMgr_Stop(int timerid);

#endif /* INC_TIMERMGR_H_ */
