/*
 *  Disclaimer and terms of usage
 *  -----------------------------
 *  Redistribution and use in source and binary forms, with or without modification,
 *  are permitted provided that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright notice,
 *     this list of conditions and the following disclaimer in the documentation
 *     and/or other materials provided with the distribution.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 *  THE POSSIBILITY OF SUCH DAMAGE.
*/
/*
 * dbprint.h
 *
 *  Created on: Mar 22, 2016
 *      Author: khgoh
 */

#ifndef DBPRINT_H_
#define DBPRINT_H_


//#define DEBUGMODE


#ifdef DEBUGMODE
#include <stdio.h>
#define dbPrintText(fmt,...) do{\
		printf("|");\
		printf((fmt),##__VA_ARGS__);\
	}while(0)
#define dbPrintContinue(fmt,...) do {\
		printf((fmt),##__VA_ARGS__);\
	}while(0)
#define dbPrintByte(pByte,size) do{\
	{int byteCounter;\
	printf("|");\
	for(byteCounter=0;byteCounter<(size);byteCounter++) {printf("%02x",(pByte)[byteCounter]);}\
	}}while(0)
#define dbPrintNewLine() do{printf("\n");}while(0)

#else
#define dbPrintText(a, ... )
#define dbPrintContinue(a, ... )
#define dbPrintByte(pByte,size)
#define dbPrintNewLine()
#endif

#endif /* DBPRINT_H_ */
