/*
 *  Disclaimer and terms of usage
 *  -----------------------------
 *  Redistribution and use in source and binary forms, with or without modification,
 *  are permitted provided that the following conditions are met:
 *
 *  1. Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 *
 *  2. Redistributions in binary form must reproduce the above copyright notice,
 *     this list of conditions and the following disclaimer in the documentation
 *     and/or other materials provided with the distribution.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 *  OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 *  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 *  THE POSSIBILITY OF SUCH DAMAGE.
*/
/*
 * text.h
 *
 *  Created on: Jul 26, 2015
 *      Author: khgoh
 */

#ifndef INC_TEXT_H_
#define INC_TEXT_H_

/*
 * Text Handling generic function
 */
/*
 * return the pointer to attribute and pointer to data
 * the expected format are as,
 * 	attribute=data
 * It will strip the comment and space at the beginig and at the end.
 * Return true if found the command format.
 */
int GetAttribute(char *src,char **attribute, char **data);

/*
 * Strip Comment from the given line
 */
char *CommStrip(char *s);

/*
 * remove beginig and ending space from a string.
 */
char *strstrip(char *s);

/*
 *Convert the string to upper case.
 */
char *strtoupper(char *s);

/*
 * Convert to upper case before compare.
 */
int strcmp_upper(char *s1,char *s2);
#endif /* INC_TEXT_H_ */
